/////////////////////////////////////////////////////////////////////////////
// Name:        wx/gtk/stattext.h
// Purpose:
// Author:      Robert Roebling
// Modified by: Christian Sturmlechner 2010/10/15-2013/11/24
// Id:          $Id: stattext.h 42077 2006-10-17 14:44:52Z ABX $
// Copyright:   (c) 1998 Robert Roebling
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef _WX_GTK_STATTEXT_H_
#define _WX_GTK_STATTEXT_H_

//-----------------------------------------------------------------------------
// wxStaticText
//-----------------------------------------------------------------------------

class WXDLLIMPEXP_CORE wxStaticText : public wxControl
{
public:
    wxStaticText();
    wxStaticText(wxWindow *parent,
                 wxWindowID id,
                 const wxString &label,
                 const wxPoint &pos = wxDefaultPosition,
                 const wxSize &size = wxDefaultSize,
                 long style = 0,
                 const wxString &name = wxStaticTextNameStr );

    bool Create(wxWindow *parent,
                wxWindowID id,
                const wxString &label,
                const wxPoint &pos = wxDefaultPosition,
                const wxSize &size = wxDefaultSize,
                long style = 0,
                const wxString &name = wxStaticTextNameStr );

    wxString GetLabel() const;
    void SetLabel( const wxString &label );
// new code start -------------------------------------------------------------------------------------------
// Modification by Christian Sturmlechner
#if wxUSE_HACKFORSTATTEXTPOSITION
    void SetPositionEx(const wxPoint& pt);
    void SetSizeEx( int width, int height );
    void SetSizeEx( const wxSize& size ) { SetSizeEx( size.x, size.y); }
#endif // wxUSE_HACKFORSTATTEXTPOSITION
// new code end ---------------------------------------------------------------------------------------------

    bool SetFont( const wxFont &font );
    bool SetForegroundColour( const wxColour& colour );

    static wxVisualAttributes
    GetClassDefaultAttributes(wxWindowVariant variant = wxWINDOW_VARIANT_NORMAL);

    // see wx/stattext.h
    void Wrap(int width);

    // implementation
    // --------------

protected:
    virtual bool GTKWidgetNeedsMnemonic() const;
    virtual void GTKWidgetDoSetMnemonic(GtkWidget* w);

    virtual void DoSetSize(int x, int y,
                           int width, int height,
                           int sizeFlags = wxSIZE_AUTO);

    virtual wxSize DoGetBestSize() const;

// new code start -------------------------------------------------------------------------------------------
// Modification by Christian Sturmlechner
#if wxUSE_HACKFORSTATTEXTPOSITION
private:
    bool bUseHackForStattextPosition;
    wxPoint PosOrig;
    wxSize SizeOrig;
#endif // wxUSE_HACKFORSTATTEXTPOSITION
// new code end ---------------------------------------------------------------------------------------------

    DECLARE_DYNAMIC_CLASS(wxStaticText)
};

#endif
    // _WX_GTK_STATTEXT_H_
