///////////////////////////////////////////////////////////////////////////////
// Name:        pdfdc.h
// Purpose:
// Author:      Ulrich Telle
// Modified by: Christian Sturmlechner 2011/03/28-2017/02/04
// Created:     2010-11-28
// Copyright:   (c) Ulrich Telle
// Licence:     wxWindows licence
///////////////////////////////////////////////////////////////////////////////

/// \file pdfdc.h Interface of the wxPdfDC class

#ifndef _PDF_DC_H_
#define _PDF_DC_H_

#include <wx/cmndata.h>
#include <wx/dc.h>

/* old code start -------------------------------------------------------------------------------------------
// Modification by Christian Sturmlechner: avoid a compile error with gcc
#include <stack>
-- old code end ------------------------------------------------------------------------------------------ */

#include "wx/pdfdocument.h"
#include "wx/pdffont.h"

#if wxCHECK_VERSION(2,9,0)
// Interface of wxPdfDC for wxWidgets 2.9.x (and above)
#include "wx/pdfdc29.h"
#else
// Interface of wxPdfDC for wxWidgets 2.8.x
#include "wx/pdfdc28.h"
#endif

// new code start -------------------------------------------------------------------------------------------
// Modification by Christian Sturmlechner - add a dummy GetFontPointSizeAdjustment()-function
#if !wxCHECK_VERSION( 2,8,12 )
#if (1) // wxABI_VERSION >= 20810
    // returns adjustment factor for converting wxFont "point size"; in wx
    // it is point size on screen and needs to be multiplied by this value
    // for rendering on higher-resolution DCs such as printer ones
    float GetFontPointSizeAdjustment(float WXUNUSED(dpi)) { return 1.0; }
#endif
#endif
// new code end ---------------------------------------------------------------------------------------------

#endif

